#include "DM_GeneralWrapper.h"

#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "sub/SubWrapperHelper.h"
#include "dpc_dm/executable.h"
#include "DM_PubDataWrapper.h"
#include "DM_SubDataWrapper.h"

GeneralWrapper::GeneralWrapper(ara::log::Logger& mainLog) : 
_DM2TRPCLong_Provide("dpc_dm/dpc_dm/DM2TRPCLongPPort" ,mainLog),
_DM2TRPCLat_Provide("dpc_dm/dpc_dm/DM2TRPCLatPPort" ,mainLog),
_DM2SM_Provide("dpc_dm/dpc_dm/DM2SMPPort" ,mainLog),
_DM2SMObjectTrim_Provide("dpc_dm/dpc_dm/DM2SMObjectTrimPPort" ,mainLog),
_DM2LongRefLine_Provide("dpc_dm/dpc_dm/DM2LongRefLinePPort" ,mainLog),
_VED2DM_Required("dpc_dm/dpc_dm/VED2DMRPort" ,mainLog),
_EM2DMRoadInfo_Required("dpc_dm/dpc_dm/EM2DMRoadInfoRPort" ,mainLog),
_EM2DMRMHeader_Required("dpc_dm/dpc_dm/EM2DMRMHeaderRPort" ,mainLog),
_EM2DMIndex_Required("dpc_dm/dpc_dm/EM2DMIndexRPort" ,mainLog),
_EM2DMCarPosition_Required("dpc_dm/dpc_dm/EM2DMCarPositionRPort" ,mainLog),
_EM2DMLane_Required("dpc_dm/dpc_dm/EM2DMLaneRPort" ,mainLog),
_EM2DMLaneMarker_Required("dpc_dm/dpc_dm/EM2DMLaneMarkerRPort" ,mainLog),
_EM2DMObject_Required("dpc_dm/dpc_dm/EM2DMObjectRPort" ,mainLog),
_EM2DMRoadEdge_Required("dpc_dm/dpc_dm/EM2DMRoadEdgeRPort" ,mainLog),
_EM2DMNeighborLane_Required("dpc_dm/dpc_dm/EM2DMNeighborLaneRPort" ,mainLog),
_EM2DMCorridor_Required("dpc_dm/dpc_dm/EM2DMCorridorRPort" ,mainLog),
_EM2DMSamplingPoint_Required("dpc_dm/dpc_dm/EM2DMSamplingPointRPort" ,mainLog),
_EM2DMLineColor_Required("dpc_dm/dpc_dm/EM2DMLineColorRPort" ,mainLog),
_EM2DMLineType_Required("dpc_dm/dpc_dm/EM2DMLineTypeRPort" ,mainLog),
_EM2DMObjectLocation_Required("dpc_dm/dpc_dm/EM2DMObjectLocationRPort" ,mainLog),
_EM2DMSLPoint_Required("dpc_dm/dpc_dm/EM2DMSLPointRPort" ,mainLog),
_EM2DMLaneControl_Required("dpc_dm/dpc_dm/EM2DMLaneControlRPort" ,mainLog),
_EM2DMLaneBoundary_Required("dpc_dm/dpc_dm/EM2DMLaneBoundaryRPort" ,mainLog),
_EM2DMLineGeometry_Required("dpc_dm/dpc_dm/EM2DMLineGeometryRPort" ,mainLog),
_EM2DMRoadEdgeSegment_Required("dpc_dm/dpc_dm/EM2DMRoadEdgeSegmentRPort" ,mainLog),
_SLAM2DMAdjacentExtendLaneStruct_Required("dpc_dm/dpc_dm/SLAM2DMAdjacentExtendLaneStructRPort" ,mainLog),
_SLAM2DMSMAStruct_Required("dpc_dm/dpc_dm/SLAM2DMSMAStructRPort" ,mainLog),
_SLAM2DMWPExtendLaneStruct_Required("dpc_dm/dpc_dm/SLAM2DMWPExtendLaneStructRPort" ,mainLog),
_SLAM2DMRemindWayPointStruct_Required("dpc_dm/dpc_dm/SLAM2DMRemindWayPointStructRPort" ,mainLog),
_SLAM2DMControlWayPointStruct_Required("dpc_dm/dpc_dm/SLAM2DMControlWayPointStructRPort" ,mainLog),
_SLAM2DMMsgHeader_Required("dpc_dm/dpc_dm/SLAM2DMMsgHeaderRPort" ,mainLog),
_SLAM2DMTransitLaneStruct_Required("dpc_dm/dpc_dm/SLAM2DMTransitLaneStructRPort" ,mainLog),
_SLAM2DMControlWayPoints_Required("dpc_dm/dpc_dm/SLAM2DMControlWayPointsRPort" ,mainLog),
_SM2Decision_Required("dpc_dm/dpc_dm/SM2DecisionRPort" ,mainLog),
_CAN2DM_Required("dpc_dm/dpc_dm/CAN2DMRPort" ,mainLog)
{

    _DM2TRPCLong_Provide.Init();
    _DM2TRPCLat_Provide.Init(_DM2TRPCLong_Provide._skeleton);
    _DM2SM_Provide.Init(_DM2TRPCLong_Provide._skeleton);
    _DM2SMObjectTrim_Provide.Init(_DM2TRPCLong_Provide._skeleton);
    _DM2LongRefLine_Provide.Init(_DM2TRPCLong_Provide._skeleton);
    _VED2DM_Required.Init();
    _EM2DMRoadInfo_Required.Init();
    _EM2DMRMHeader_Required.Init();
    _EM2DMIndex_Required.Init();
    _EM2DMCarPosition_Required.Init();
    _EM2DMLane_Required.Init();
    _EM2DMLaneMarker_Required.Init();
    _EM2DMObject_Required.Init();
    _EM2DMRoadEdge_Required.Init();
    _EM2DMNeighborLane_Required.Init();
    _EM2DMCorridor_Required.Init();
    _EM2DMSamplingPoint_Required.Init();
    _EM2DMLineColor_Required.Init();
    _EM2DMLineType_Required.Init();
    _EM2DMObjectLocation_Required.Init();
    _EM2DMSLPoint_Required.Init();
    _EM2DMLaneControl_Required.Init();
    _EM2DMLaneBoundary_Required.Init();
    _EM2DMLineGeometry_Required.Init();
    _EM2DMRoadEdgeSegment_Required.Init();
    _SLAM2DMAdjacentExtendLaneStruct_Required.Init();
    _SLAM2DMSMAStruct_Required.Init();
    _SLAM2DMWPExtendLaneStruct_Required.Init();
    _SLAM2DMRemindWayPointStruct_Required.Init();
    _SLAM2DMControlWayPointStruct_Required.Init();
    _SLAM2DMMsgHeader_Required.Init();
    _SLAM2DMTransitLaneStruct_Required.Init();
    _SLAM2DMControlWayPoints_Required.Init();
    _SM2Decision_Required.Init();
    _CAN2DM_Required.Init();
}
GeneralWrapper::~GeneralWrapper() {
    _VED2DM_Required.Destroy();
    _EM2DMRoadInfo_Required.Destroy();
    _EM2DMRMHeader_Required.Destroy();
    _EM2DMIndex_Required.Destroy();
    _EM2DMCarPosition_Required.Destroy();
    _EM2DMLane_Required.Destroy();
    _EM2DMLaneMarker_Required.Destroy();
    _EM2DMObject_Required.Destroy();
    _EM2DMRoadEdge_Required.Destroy();
    _EM2DMNeighborLane_Required.Destroy();
    _EM2DMCorridor_Required.Destroy();
    _EM2DMSamplingPoint_Required.Destroy();
    _EM2DMLineColor_Required.Destroy();
    _EM2DMLineType_Required.Destroy();
    _EM2DMObjectLocation_Required.Destroy();
    _EM2DMSLPoint_Required.Destroy();
    _EM2DMLaneControl_Required.Destroy();
    _EM2DMLaneBoundary_Required.Destroy();
    _EM2DMLineGeometry_Required.Destroy();
    _EM2DMRoadEdgeSegment_Required.Destroy();
    _SLAM2DMAdjacentExtendLaneStruct_Required.Destroy();
    _SLAM2DMSMAStruct_Required.Destroy();
    _SLAM2DMWPExtendLaneStruct_Required.Destroy();
    _SLAM2DMRemindWayPointStruct_Required.Destroy();
    _SLAM2DMControlWayPointStruct_Required.Destroy();
    _SLAM2DMMsgHeader_Required.Destroy();
    _SLAM2DMTransitLaneStruct_Required.Destroy();
    _SLAM2DMControlWayPoints_Required.Destroy(); 
    _SM2Decision_Required.Destroy();
    _CAN2DM_Required.Destroy();
}

void GeneralWrapper::Start() {
    
}

